--- /dev/null	Sun Aug  5 23:41:08 2018
+++ new/usr/src/man/man3c/bind.3c	Sun Aug  5 23:41:08 2018
@@ -0,0 +1,125 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (C) 2009, Sun Microsystems, Inc. All Rights Reserved
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt BIND 3C
+.Os
+.Sh NAME
+.Nm bind
+.Nd bind a name to a socket
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo bind
+.Fa "int s"
+.Fa "const struct sockaddr *name"
+.Fa "socklen_t namelen"
+.Fc
+.Sh DESCRIPTION
+The
+.Fn bind
+function assigns a name to an unnamed socket.
+When a socket is created with
+.Xr socket 3C ,
+it exists in a name space (address family) but has no name assigned.
+The
+.Fn bind
+function requests that the name pointed to by
+.Fa name
+be assigned to the socket.
+.Sh RETURN VALUES
+Upon successful completion 0 is returned.
+Otherwise, -1
+is returned and
+.Va errno
+is set to indicate the error.
+.Sh ERRORS
+The
+.Fn bind
+function will fail if:
+.Bl -tag -width Er
+.It Bq Er EACCES
+The requested address is protected, and
+.Bq Dv PRIV_NET_PRIVADDR
+is not asserted in the effective set of the current process.
+.It Bq Er EADDRINUSE
+The specified address is already in use.
+.It Bq Er EADDRNOTAVAIL
+The specified address is not available on the local machine.
+.It Bq Er EBADF
+.Fa s
+is not a valid descriptor.
+.It Bq Er EINVAL
+.Fa namelen
+is not the size of a valid address for the specified address family.
+.Pp
+The socket is already bound to an address.
+.Pp
+Socket options are inconsistent with port attributes.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources for the operation to complete.
+.It Bq Er ENOTSOCK
+.Fa s
+is a descriptor for a file, not a socket.
+.El
+.Pp
+The following errors are specific to binding names in the UNIX domain:
+.Bl -tag -width Er
+.It Bq Er EACCES
+Search permission is denied for a component of the path prefix of the pathname
+in
+.Fa name .
+.It Bq Er EIO
+An I/O error occurred while making the directory entry or allocating the inode.
+.It Bq Er EISDIR
+A null pathname was specified.
+.It Bq Er ELOOP
+Too many symbolic links were encountered in translating the pathname in
+.Fa name .
+.It Bq Er ENOENT
+A component of the path prefix of the pathname in
+.Fa name
+does not exist.
+.It Bq Er ENOTDIR
+A component of the path prefix of the pathname in
+.Fa name
+is not a directory.
+.It Bq Er EROFS
+The inode would reside on a read-only file system.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr unlink 2 ,
+.Xr sockaddr 3C ,
+.Xr socket 3C ,
+.Xr socket.h 3HEAD ,
+.Xr attributes 5 ,
+.Xr privileges 5
+.Sh NOTES
+Binding a name in the UNIX domain creates a socket in the file system that must
+be deleted by the caller when it is no longer needed by using
+.Xr unlink 2 .
+.Pp
+The rules used in name binding vary between communication domains.
--- /dev/null	Sun Aug  5 23:41:08 2018
+++ new/usr/src/man/man3c/connect.3c	Sun Aug  5 23:41:08 2018
@@ -0,0 +1,379 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T  All Rights Reserved
+.\" Copyright (C) 2005, Sun Microsystems, Inc. All Rights Reserved.
+.\" Copyright (c) 2014, Joyent, Inc.
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt CONNECT 3C
+.Os
+.Sh NAME
+.Nm connect
+.Nd initiate a connection on a socket
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo connect
+.Fa "int s"
+.Fa "const struct sockaddr *name"
+.Fa "socklen_t namelen"
+.Fc
+.Sh DESCRIPTION
+The parameter
+.Fa s
+is a socket.
+If it is of type
+.Dv SOCK_DGRAM ,
+.Fn connect
+specifies the peer with which the socket is to be associated.
+This address is the address to which datagrams are to be sent if a receiver is
+not explicitly designated.
+This address is the only address from which datagrams are to be received.
+If the socket
+.Fa s
+is of type
+.Dv SOCK_STREAM ,
+.Fn connect
+attempts to make a connection to another socket.
+The other socket is specified by
+.Fa name .
+.Fa name
+is an address in the communication space of the socket.
+Each communication space interprets the
+.Fa name
+parameter in its own way.
+If
+.Fa s
+is not bound, then
+.Fa s
+will be bound to an address selected by the underlying transport provider.
+Generally, stream sockets can successfully
+.Fn connect
+only once.
+Datagram sockets can use
+.Fn connect
+multiple times to change their association.
+Datagram sockets can dissolve the association by connecting to a null address.
+.Ss Non-blocking Sockets
+When a socket is created, it is by default a blocking socket.
+A socket may be configured to be non-blocking either at socket creation time or
+through the use of
+.Xr fcntl 2 .
+When a socket is set to be non-blocking, a call to
+.Fn connect
+initiates an asynchronous connection.
+If the connection cannot be completed without blocking, such as when making a
+TCP connection to a remote server, then  the connection attempt is made in the
+background and
+.Fn connect
+returns -1 and
+.Va errno
+is set to
+.Er EINPROGRESS .
+.Pp
+Applications can obtain the state of this connection attempt by polling the
+socket's file descriptor for
+.Dv POLLOUT .
+The event ports facility is the preferred means of polling on the file
+descriptor, see
+.Xr port_create 3C
+and
+.Xr port_get 3C
+for more information on event ports; however, applications may also use
+traditional portable routines like
+.Xr poll 2
+and
+.Xr select 3C .
+.Pp
+When an asynchronous connection has completed, the application must call
+.Xr getsockopt 3C
+using the macro
+.Dv SOL_SOCKET
+as the
+.Fa level
+argument and the macro
+.Dv SO_ERROR
+as the value of the
+.Fa option
+argument.
+If the value of the
+.Dv SO_ERROR
+socket option is zero, then the connect was successfully established.
+Otherwise, the connection could not be established and the value is the
+corresponding error code that would be commonly found in
+.Va errno .
+.Pp
+Even when a socket is in non-blocking mode, a call to
+.Fn connect
+may fail synchronously.
+If any error other than
+.Er EINPROGRESS
+or
+.Er EINTR
+occurs, then there is no need for the application to poll for asynchronous
+completion.
+Similarly, if a call to
+.Fn connect
+returns successfully, then the socket connection will be established and there
+is no need to poll for completion.
+.Sh RETURN VALUES
+If the connection or binding succeeds, 0 is returned.
+Otherwise, -1 is returned and sets
+.Va errno
+to indicate the error.
+.Sh EXAMPLES
+.Bl -tag -width Ds
+.It Sy Example 1 No Performing an asynchronous connection
+The following sample C program shows how to create and connect to a remote host
+using TCP.
+.Bd -literal
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <inttypes.h>
+#include <stdio.h>
+#include <strings.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <port.h>
+#include <unistd.h>
+#include <assert.h>
+
+int
+main(int argc, char *argv[])
+{
+	char *eptr;
+	long port;
+	int sock, ret, eport;
+	struct sockaddr_in6 sin6;
+
+	if (argc != 3) {
+		fprintf(stderr, "connect: <IP> <port>\\n");
+		return (1);
+	}
+
+	bzero(&sin6, sizeof (struct sockaddr_in6));
+	sin6.sin6_family = AF_INET6;
+
+	/*
+	 * Try to parse as an IPv6 address and then try v4.
+	 */
+	ret = inet_pton(AF_INET6, argv[1], &sin6.sin6_addr);
+	if (ret == -1) {
+		perror("inet_pton");
+		return (1);
+	} else if (ret == 0) {
+		struct in_addr v4;
+		ret = inet_pton(AF_INET, argv[1], &v4);
+		if (ret == -1) {
+			perror("inet_pton");
+			return (1);
+		} else if (ret == 0) {
+			fprintf(stderr, "connect: %s is not a valid "
+			    "IPv4 or IPv6 address\\n", argv[1]);
+			return (1);
+		}
+		/* N.B. Not a portable macro */
+		IN6_INADDR_TO_V4MAPPED(&v4, &sin6.sin6_addr);
+	}
+
+	errno = 0;
+	port = strtol(argv[2], &eptr, 10);
+	if (errno != 0 || *eptr != '\e0') {
+		fprintf(stderr, "failed to parse port %s\\n", argv[2]);
+		return (1);
+	}
+	if (port <= 0 || port > UINT16_MAX) {
+		fprintf(stderr, "invalid port: %ld\\n", port);
+		return (1);
+	}
+	sin6.sin6_port = htons(port);
+
+	sock = socket(AF_INET6, SOCK_STREAM | SOCK_NONBLOCK, 0);
+	if (sock < 0) {
+		perror("socket");
+		return (1);
+	}
+
+	eport = port_create();
+	if (eport < 0) {
+		perror("port_create");
+		(void) close(sock);
+		return (1);
+	}
+
+	ret = connect(sock, (struct sockaddr *)&sin6,
+	    sizeof (struct sockaddr_in6));
+	if (ret != 0 && errno != EINPROGRESS && errno != EINTR) {
+		perror("connect");
+		(void) close(sock);
+		(void) close(eport);
+		return (1);
+	}
+
+	if (ret != 0) {
+		port_event_t pe;
+		int err;
+		socklen_t sz = sizeof (err);
+		if (port_associate(eport, PORT_SOURCE_FD, sock, POLLOUT,
+		    NULL) != 0) {
+			perror("port_associate");
+			(void) close(sock);
+			(void) close(eport);
+			return (1);
+		}
+		if (port_get(eport, &pe, NULL) != 0) {
+			perror("port_get");
+			(void) close(sock);
+			(void) close(eport);
+			return (1);
+		}
+		assert(pe.portev_source == PORT_SOURCE_FD);
+		assert(pe.portev_object == (uintptr_t)sock);
+		if (getsockopt(sock, SOL_SOCKET, SO_ERROR, &err, &sz) != 0) {
+			perror("getsockopt");
+			(void) close(sock);
+			(void) close(eport);
+			return (1);
+		}
+		if (err != 0) {
+			/* Asynch connect failed */
+			fprintf(stderr, "asnchronous connect: %s\\n",
+			    strerror(err));
+			(void) close(sock);
+			(void) close(eport);
+			return (1);
+		}
+	}
+
+	/* Read and write to the socket and then clean up */
+
+	return (0);
+}
+.Ed
+.El
+.Sh ERRORS
+The call fails if:
+.Bl -tag -width Er
+.It Bq Er EACCES
+Search permission is denied for a component of the path prefix of the pathname
+in
+.Fa name .
+.It Bq Er EADDRINUSE
+The address is already in use.
+.It Bq Er EADDRNOTAVAIL
+The specified address is not available on the remote machine.
+.It Bq Er EAFNOSUPPORT
+Addresses in the specified address family cannot be used with this socket.
+.It Bq Er EALREADY
+The socket is non-blocking,  and a previous connection attempt has not yet been
+completed.
+.It Bq Er EBADF
+.Fa s
+is not a valid descriptor.
+.It Bq Er ECONNREFUSED
+The attempt to connect was forcefully rejected.
+The calling program should
+.Xr close 2
+the socket descriptor, and issue another
+.Xr socket 3C
+call to obtain a new descriptor before attempting another
+.Fn connect
+call.
+.It Bq Er EINPROGRESS
+The socket is non-blocking, and the connection cannot be completed immediately.
+See the section on
+.Sx Non-blocking Sockets
+for more information.
+.It Bq Er EINTR
+The connection attempt was interrupted before any data arrived by the delivery
+of a signal.
+The connection, however, will be established asynchronously.
+.It Bq Er EINVAL
+.Fa namelen
+is not the size of a valid address for the specified address family.
+.It Bq Er EIO
+An I/O error occurred while reading from or writing to the file system.
+.It Bq Er EISCONN
+The socket is already connected.
+.It Bq Er ELOOP
+Too many symbolic links were encountered in translating the pathname in
+.Fa name .
+.It Bq Er ENETUNREACH
+The network is not reachable from this host.
+.It Bq Er EHOSTUNREACH
+The remote host is not reachable from this host.
+.It Bq Er ENOENT
+A component of the path prefix of the pathname in
+.Fa name
+does not exist.
+.Pp
+The socket referred to by the pathname in
+.Fa name
+does not exist.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources available to complete the operation.
+.It Bq Er ENXIO
+The server exited before the connection was complete.
+.It Bq Er ETIMEDOUT
+Connection establishment timed out without establishing a connection.
+.It Bq Er EWOULDBLOCK
+The socket is marked as non-blocking, and the requested operation would block.
+.El
+.Pp
+The following errors are specific to connecting names in the UNIX domain.
+These errors might not apply in future versions of the UNIX IPC domain.
+.Bl -tag -width Er
+.It Bq Er ENOTDIR
+A component of the path prefix of the pathname in
+.Fa name
+is not a directory.
+.It Bq Er ENOTSOCK
+.Fa s
+is not a socket.
+.It Bq Er EPROTOTYPE
+The file that is referred to by
+.Fa name
+is a socket of a type other than type
+.Fa s .
+For example,
+.Fa s
+is a
+.Dv SOCK_DGRAM
+socket, while
+.Fa name
+refers to a
+.Dv SOCK_STREAM
+socket.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr close 2 ,
+.Xr accept 3C ,
+.Xr getsockname 3C ,
+.Xr select 3C ,
+.Xr sockaddr 3C ,
+.Xr socket 3C ,
+.Xr socket.h 3HEAD ,
+.Xr attributes 5
--- /dev/null	Sun Aug  5 23:41:09 2018
+++ new/usr/src/man/man3c/getpeername.3c	Sun Aug  5 23:41:09 2018
@@ -0,0 +1,86 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (c) 1998, Sun Microsystems, Inc.  All Rights Reserved
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt GETPEERNAME 3C
+.Os
+.Sh NAME
+.Nm getpeername
+.Nd get name of connected peer
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo getpeername
+.Fa "int s"
+.Fa "struct sockaddr *restrict name"
+.Fa "socklen_t *namelen"
+.Fc
+.Sh DESCRIPTION
+.Fn getpeername
+returns the name of the peer connected to socket
+.Fa s .
+The
+.Vt int
+pointed to by the
+.Fa namelen
+parameter should be initialized to indicate the amount of space pointed to by
+.Fa name .
+On return it contains the actual size of the name returned (in bytes), prior to
+any truncation.
+The name is truncated if the buffer provided is too small.
+.Sh RETURN VALUES
+If successful,
+.Fn getpeername
+returns 0; otherwise it returns -1 and sets
+.Va errno
+to indicate the error.
+.Sh ERRORS
+The call succeeds unless:
+.Bl -tag -width Er
+.It Bq Er EBADF
+The argument
+.Fa s
+is not a valid descriptor.
+.It Bq Er ENOMEM
+There was insufficient user memory for the operation to complete.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources available for the operation to
+complete.
+.It Bq Er ENOTCONN
+The socket is not connected.
+.It Bq Er ENOTSOCK
+The argument
+.Fa s
+is not a socket.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr accept 3C ,
+.Xr bind 3C ,
+.Xr getsockname 3C ,
+.Xr sockaddr 3C ,
+.Xr socket 3C ,
+.Xr socket.h 3HEAD ,
+.Xr attributes 5
--- /dev/null	Sun Aug  5 23:41:09 2018
+++ new/usr/src/man/man3c/getsockname.3c	Sun Aug  5 23:41:09 2018
@@ -0,0 +1,80 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (c) 1997, Sun Microsystems, Inc.  All Rights Reserved
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt GETSOCKNAME 3C
+.Os
+.Sh NAME
+.Nm getsockname
+.Nd get socket name
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo getsockname
+.Fa "int s"
+.Fa "struct sockaddr *restrict name"
+.Fa "socklen_t *namelen"
+.Fc
+.Sh DESCRIPTION
+.Fn getsockname
+returns the current
+.Fa name
+for socket
+.Fa s .
+The
+.Fa namelen
+parameter should be initialized to indicate the amount of space pointed to by
+.Fa name .
+On return it contains the actual size in bytes of the name returned.
+.Sh RETURN VALUES
+If successful,
+.Fn getsockname
+returns 0; otherwise it returns -1 and sets
+.Va errno
+to indicate the error.
+.Sh ERRORS
+The call succeeds unless:
+.Bl -tag -width Er
+.It Bq Er EBADF
+The argument
+.Fa s
+is not a valid file descriptor.
+.It Bq Er ENOMEM
+There was insufficient memory available for the operation to complete.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources available for the operation to
+complete.
+.It Bq Er ENOTSOCK
+The argument
+.Fa s
+is not a socket.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr bind 3C ,
+.Xr getpeername 3C ,
+.Xr sockaddr 3C ,
+.Xr socket 3C ,
+.Xr attributes 5
--- /dev/null	Sun Aug  5 23:41:09 2018
+++ new/usr/src/man/man3c/getsockopt.3c	Sun Aug  5 23:41:09 2018
@@ -0,0 +1,466 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (C) 2009, Sun Microsystems, Inc. All Rights Reserved
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt GETSOCKOPT 3C
+.Os
+.Sh NAME
+.Nm getsockopt ,
+.Nm setsockopt
+.Nd get and set options on sockets
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo getsockopt
+.Fa "int s"
+.Fa "int level"
+.Fa "int optname"
+.Fa "void *restrict optval"
+.Fa "socklen_t *optlen"
+.Fc
+.Ft int
+.Fo setsockopt
+.Fa "int s"
+.Fa "int level"
+.Fa "int optname"
+.Fa "const void *optval"
+.Fa "socklen_t optlen"
+.Fc
+.Sh DESCRIPTION
+The
+.Fn getsockopt
+and
+.Fn setsockopt
+functions manipulate options associated with a socket.
+Options may exist at multiple protocol levels; they are always present at the
+uppermost "socket" level.
+.Pp
+The
+.Fa level
+argument specifies the protocol level at which the option resides.
+To manipulate options at the socket level, specify the
+.Fa level
+argument as
+.Dv SOL_SOCKET .
+To manipulate options at the protocol level, supply the appropriate protocol
+number for the protocol controlling the option.
+For example, to indicate that an option will be interpreted by the TCP, set
+.Fa level
+to the protocol number of TCP, as defined in the
+.In netinet/in.h
+header, or as determined by using
+.Xr getprotobyname 3SOCKET .
+Some socket protocol families may also define additional levels, such as
+.Dv SOL_ROUTE .
+Only socket-level options are described here.
+.Pp
+The parameters
+.Fa optval
+and
+.Fa optlen
+are used to access option values for
+.Fn setsockopt .
+For
+.Fn getsockopt ,
+they identify a buffer in which the value(s) for the requested option(s) are to
+be returned.
+For
+.Fn getsockopt ,
+.Fa optlen
+is a value-result parameter, initially containing the size of the buffer pointed
+to by
+.Fa optval ,
+and modified on return to indicate the actual size of the value returned.
+Use a 0
+.Fa optval
+if no option value is to be supplied or returned.
+.Pp
+The
+.Fa optname
+and any specified options are passed uninterpreted to the appropriate protocol
+module for interpretation.
+The include file
+.In sys/socket.h
+contains definitions for the socket-level options described below.
+Options at other protocol levels vary in format and name.
+.Pp
+Most socket-level options take an
+.Vt int
+for
+.Fa optval .
+For
+.Fn setsockopt ,
+the
+.Fa optval
+parameter should be non-zero to enable a boolean option, or zero if the option
+is to be disabled.
+.Dv SO_LINGER
+uses a
+.Vt "struct linger"
+parameter that specifies the desired state of the option and the linger
+interval.
+.Vt "struct linger"
+is defined in
+.In sys/socket.h .
+.Vt "struct linger"
+contains the following members:
+.Bl -tag -width "l_linger"
+.It Va l_onoff
+on = 1/off = 0
+.It Va l_linger
+linger time, in seconds
+.El
+.Pp
+The following options are recognized at the socket level.
+Except as noted, each may be examined with
+.Fn getsockopt
+and set with
+.Fn setsockopt .
+.Bl -tag -width "SO_DGRAM_ERRIND"
+.It Dv SO_DEBUG
+enable/disable recording of debugging information
+.It Dv SO_REUSEADDR
+enable/disable local address reuse
+.It Dv SO_KEEPALIVE
+enable/disable keep connections alive
+.It Dv SO_DONTROUTE
+enable/disable routing bypass for outgoing messages
+.It Dv SO_LINGER
+linger on close if data is present
+.It Dv SO_BROADCAST
+enable/disable permission to transmit broadcast messages
+.It Dv SO_OOBINLINE
+enable/disable reception of out-of-band data in band
+.It Dv SO_SNDBUF
+set buffer size for output
+.It Dv SO_RCVBUF
+set buffer size for input
+.It Dv SO_DGRAM_ERRIND
+application wants delayed error
+.It Dv SO_TIMESTAMP
+enable/disable reception of timestamp with datagrams
+.It Dv SO_EXCLBIND
+enable/disable exclusive binding of the socket
+.It Dv SO_TYPE
+get the type of the socket (get only)
+.It Dv SO_ERROR
+get and clear error on the socket (get only)
+.It Dv SO_MAC_EXEMPT
+get or set mandatory access control on the socket.
+This option is available only when the system is configured with Trusted
+Extensions.
+.It Dv SO_ALLZONES
+bypass zone boundaries (privileged).
+.It Dv SO_DOMAIN
+get the domain used in the socket (get only)
+.It Dv SO_PROTOTYPE
+for socket in domains
+.Dv PF_INET
+and
+.Dv PF_INET6 ,
+get the underlying protocol number used in the socket.
+For socket in domain
+.Dv PF_ROUTE ,
+get the address family used in the socket.
+.El
+.Pp
+The
+.Dv SO_DEBUG
+option enables debugging in the underlying protocol modules.
+The
+.Dv SO_REUSEADDR
+option indicates that the rules used in validating addresses supplied in a
+.Xr bind 3C
+call should allow reuse of local addresses.
+The
+.Dv SO_KEEPALIVE
+option enables the periodic transmission of messages on a connected socket.
+If the connected party fails to respond to these messages, the connection is
+considered broken and threads using the socket are notified using a
+.Dv SIGPIPE
+signal.
+The
+.Dv SO_DONTROUTE
+option indicates that outgoing messages should bypass the standard routing
+facilities.
+Instead, messages are directed to the appropriate network interface according
+to the network portion of the destination address.
+.Pp
+The
+.Dv SO_LINGER
+option controls the action taken when unsent messages are queued on a socket and
+a
+.Xr close 2
+is performed.
+If the socket promises reliable delivery of data and
+.Dv SO_LINGER
+is set, the system will block the thread on the
+.Xr close 2
+attempt until it is able to transmit the data or until it decides it is unable
+to deliver the information (a timeout period, termed the linger interval, is
+specified in the
+.Fn setsockopt
+call when
+.Dv SO_LINGER
+is requested).
+If
+.Dv SO_LINGER
+is disabled and a
+.Xr close 2
+is issued, the system will process the
+.Xr close 2
+in a manner that allows the thread to continue as quickly as possible.
+.Pp
+The option
+.Dv SO_BROADCAST
+requests permission to send broadcast datagrams on the socket.
+With protocols that support out-of-band data, the
+.Dv SO_OOBINLINE
+option requests that out-of-band data be placed in the normal data input queue
+as received; it will then be accessible with
+.Xr recv 3C
+or
+.Xr read 2
+calls without the
+.Dv MSG_OOB
+flag.
+.Pp
+The
+.Dv SO_SNDBUF
+and
+.Dv SO_RCVBUF
+options adjust the normal buffer sizes allocated for output and input buffers,
+respectively.
+The buffer size may be increased for high-volume connections or may be decreased
+to limit the possible backlog of incoming data.
+The maximum buffer size for UDP is determined by the value of the
+.Xr ndd 1M
+variable
+.Cm udp_max_buf .
+The maximum buffer size for TCP is determined the value of the
+.Xr ndd 1M
+variable
+.Cm tcp_max_buf .
+Use the
+.Xr ndd 1M
+utility to determine the current default values.
+At present, lowering
+.Dv SO_RCVBUF
+on a TCP connection after it has been established has no effect.
+.Pp
+By default, delayed errors (such as ICMP
+.Dq Port Unreachable
+packets) are returned only for connected datagram sockets.
+The
+.Dv SO_DGRAM_ERRIND
+option makes it possible to receive errors for datagram sockets that are not
+connected.
+When this option is set, certain delayed errors received after completion of a
+.Xr sendto 3C
+or
+.Xr sendmsg 3C
+operation will cause a subsequent
+.Xr sendto 3C
+or
+.Xr sendmsg 3C
+operation using the same destination address
+.Po Fa to
+parameter
+.Pc
+to fail with the appropriate error.
+See
+.Xr send 3C .
+.Pp
+If the
+.Dv SO_TIMESTAMP
+option is enabled on a
+.Dv SO_DGRAM
+or a
+.Dv SO_RAW
+socket, the
+.Xr recvmsg 3XNET
+call will return a timestamp in the native data format, corresponding to when
+the datagram was received.
+.Pp
+The
+.Dv SO_EXCLBIND
+option is used to enable or disable the exclusive binding of a socket.
+It overrides the use of the
+.Dv SO_REUSEADDR
+option to reuse an address on
+.Xr bind 3C .
+The actual semantics of the
+.Dv SO_EXCLBIND
+option depend on the underlying protocol.
+See
+.Xr tcp 7P
+or
+.Xr udp 7P
+for more information.
+.Pp
+The
+.Dv SO_TYPE
+and
+.Dv SO_ERROR
+options are used only with
+.Fn getsockopt .
+The
+.Dv SO_TYPE
+option returns the type of the socket, for example,
+.Dv SOCK_STREAM .
+It is useful for servers that inherit sockets on startup.
+The
+.Dv SO_ERROR
+option returns any pending error on the socket and clears the error status.
+It may be used to check for asynchronous errors on connected datagram sockets or
+for other asynchronous errors.
+.Pp
+The
+.Dv SO_MAC_EXEMPT
+option is used to toggle socket behavior with unlabeled peers.
+A socket that has this option enabled can communicate with an unlabeled peer if
+it is in the global zone or has a label that dominates the default label of the
+peer.
+Otherwise, the socket must have a label that is equal to the default label of
+the unlabeled peer.
+Calling
+.Fn setsockopt
+with this option returns an
+.Er EACCES
+error if the process lacks the
+.Dv NET_MAC_AWARE
+privilege or if the socket is bound.
+The
+.Dv SO_MAC_EXEMPT
+option is available only when the system is configured with Trusted Extensions.
+.Pp
+The
+.Dv SO_ALLZONES
+option can be used to bypass zone boundaries between shared-IP zones.
+Normally, the system prevents a socket from being bound to an address that is
+not assigned to the current zone.
+It also prevents a socket that is bound to a wildcard address from receiving
+traffic for other zones.
+However, some daemons which run in the global zone might need to send and
+receive traffic using addresses that belong to other shared-IP zones.
+If set before a socket is bound,
+.Dv SO_ALLZONES
+causes the socket to ignore zone boundaries between shared-IP zones and permits
+the socket to be bound to any address assigned to the shared-IP zones.
+If the socket is bound to a wildcard address, it receives traffic intended for
+all shared-IP zones and behaves as if an equivalent socket were bound in each
+active shared-IP zone.
+Applications that use the
+.Dv SO_ALLZONES
+option to initiate connections or send datagram traffic should specify the
+source address for outbound traffic by binding to a specific address.
+There is no effect from setting this option in an exclusive-IP zone.
+Setting this option requires the
+.Em sys_net_config
+privilege.
+See
+.Xr zones 5 .
+.Sh RETURN VALUES
+If successful,
+.Fn getsockopt
+and
+.Fn setsockopt
+return 0.
+Otherwise, the functions return -1 and set
+.Va errno
+to indicate the error.
+.Sh ERRORS
+The
+.Fn getsockopt
+and
+.Fn setsockopt
+calls succeed unless:
+.Bl -tag -width Er
+.It Bq Er EBADF
+The argument
+.Fa s
+is not a valid file descriptor.
+.It Bq Er ENOMEM
+There was insufficient memory available for the operation to complete.
+.It Bq Er ENOPROTOOPT
+The option is unknown at the level indicated.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources available for the operation to
+complete.
+.It Bq Er ENOTSOCK
+The argument
+.Fa s
+is not a socket.
+.It Bq Er ENOBUFS
+.Dv SO_SNDBUF
+or
+.Dv SO_RCVBUF
+exceeds a system limit.
+.It Bq Er EINVAL
+Invalid length for a given socket option.
+.It Bq Er EHOSTUNREACH
+Invalid address for
+.Dv IP_MULTICAST_IF .
+.It Bq Er EINVAL
+Not a multicast address for
+.Dv IP_ADD_MEMBERSHIP
+and
+.Dv IP_DROP_MEMBERSHIP .
+.It Bq Er EADDRNOTAVAIL
+Bad interface address for
+.Dv IP_ADD_MEMBERSHIP
+and
+.Dv IP_DROP_MEMBERSHIP .
+.It Bq Er EADDRINUSE
+Address already joined for
+.Dv IP_ADD_MEMBERSHIP .
+.It Bq Er ENOENT
+Address not joined for
+.Dv IP_DROP_MEMBERSHIP .
+.It Bq Er EPERM
+No permissions.
+.It Bq Er EACCES
+Permission denied.
+.It Bq Er EINVAL
+The specified option is invalid at the specified socket level, or the socket
+has been shut down.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr ndd 1M ,
+.Xr close 2 ,
+.Xr ioctl 2 ,
+.Xr read 2 ,
+.Xr bind 3C ,
+.Xr recv 3C ,
+.Xr send 3C ,
+.Xr socket 3C ,
+.Xr socket.h 3HEAD ,
+.Xr getprotobyname 3SOCKET ,
+.Xr recvmsg 3XNET ,
+.Xr attributes 5 ,
+.Xr zones 5 ,
+.Xr tcp 7P ,
+.Xr udp 7P
